<?php

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

class MyPolls_Plugin
{ 
    var $my_config;
    var $plugin_name = 'MyPolls';
    var $prefixeTable;
    var $pagelink= 'admin.php?page=plugin&section=mypolls%2Fadmin%2Fplugin_admin.php';

    var $polls_table; 
    var $polls_by_user_table; 

	/* ----------------------------------------------------------------------------------------------
		FONCTIONS STANDARDS
	   ---------------------------------------------------------------------------------------------- */

	/* initialise le tableau de configuration */
	function init_config()
	{
		$this->my_config=array(
				'MyPolls_MouseOverColor' => '303030',
				'MyPolls_BarColor' => '6666ff',
				'MyPolls_MaxBarWidth' => '400',
				'MyPolls_allow_guests_default' => 'n',
				'MyPolls_visible_default' => 'y',
				'MyPolls_MenuBar_Title' => ''
				);
	}

	function init($prefixeTable)
	{
		$this->prefixeTable = $prefixeTable;
		$this->polls_table = $this->prefixeTable.$this->plugin_name."_polls";
		$this->polls_by_user_table = $this->prefixeTable.$this->plugin_name."_polls_by_user";
	}

	/* charge la configuration */
	function load_config()
	{
		$this->init_config();
		$sql="SELECT value FROM ".CONFIG_TABLE." WHERE param = '".$this->plugin_name."_config'";
		$result=pwg_query($sql);
		if($result)
		{
			$row=mysql_fetch_row($result);
			if(is_string($row[0])) 
			{
				$c = unserialize($row[0]);
				reset($c);
				while (list($key, $val) = each($c)) 
				{ $this->my_config[$key] = $val; }
			}
		}
	}

	/* sauvegarde de la configuration dans la table config */
	function save_config()
	{
	 $sql="REPLACE INTO ".CONFIG_TABLE." VALUES('".$this->plugin_name."_config', '".serialize($this->my_config)."', '')"; 
	 $result=pwg_query($sql);
	 if($result) { return true; } else { return false; }
	}

	/* suppression de la configuration dans la table config */
	function delete_config()
	{
	 $sql="DELETE FROM ".CONFIG_TABLE." WHERE param='".$this->plugin_name."_config'"; 
	 $result=pwg_query($sql);
	 if($result) { return true; } else { return false; }
	}

	/* intégration du plugin dans l'interface d'administration */
	function plugin_admin_menu($menu)
	{
	 array_push($menu,
	            array(
	                'NAME' => $this->plugin_name,
	                'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/plugin_admin.php')
	                 ));
	 return $menu;
	}

	function Modifie_CSS()
	{
	  global $template;

		$text = "
.TableRow:hover { 
	background-color:#".$this->my_config['MyPolls_MouseOverColor']."; 
	}
.formtable, .formtable P { 
	text-align:left; display:block; 
	}
.polltxt, .polltxt P {
	text-align:left; 
	display:block; 
	margin:8px;
	}
.MyPollBar {
	border:0px; 
	height:8px;
	display: block;
	margin:0px;
	padding:0px;
	left:0;
	position:relative;
	background-color:#".$this->my_config['MyPolls_BarColor']."; top:0px;  
	}";
		$template->assign_block_vars('head_element', array('CONTENT' => '<style type="text/css"> '.$text.' </style>'));
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS A L'INSTALLATION DU PLUGIN
	   ---------------------------------------------------------------------------------------------- */
	
	/* création des tables polls */
	function create_tables()
	{
		//on supprime les tables si elles existent déjà
		$this->drop_tables();

		$sql="CREATE TABLE `".$this->prefixeTable.$this->plugin_name."_polls` (
			  `id` int(11) NOT NULL auto_increment,
			  `date` datetime NOT NULL default '0000-00-00 00:00:00',
			  `title` varchar(250) NOT NULL default '',
			  `description` text,
			  `allow_guests` char(1) NOT NULL default 'n',
			  `visible` char(1) NOT NULL default 'y',
			  `c1_text` varchar(250) default '',
			  `c1_choose` int(11) NOT NULL default '0',
			  `c2_text` varchar(250) default '',
			  `c2_choose` int(11) NOT NULL default '0',
			  `c3_text` varchar(250) default '',
			  `c3_choose` int(11) NOT NULL default '0',
			  `c4_text` varchar(250) default '',
			  `c4_choose` int(11) NOT NULL default '0',
			  `c5_text` varchar(250) default '',
			  `c5_choose` int(11) NOT NULL default '0',
			  `c6_text` varchar(250) default '',
			  `c6_choose` int(11) NOT NULL default '0',
			  `c7_text` varchar(250) default '',
			  `c7_choose` int(11) NOT NULL default '0',
			  `c8_text` varchar(250) default '',
			  `c8_choose` int(11) NOT NULL default '0',
			  `c9_text` varchar(250) default '',
			  `c9_choose` int(11) NOT NULL default '0',
			  `c10_text` varchar(250) default '',
			  `c10_choose` int(11) NOT NULL default '0',
			  `total` int(11) NOT NULL default '0',
			  `visit_without_vote` int(11) NOT NULL default '0',
			  `visit_after_vote` int(11) NOT NULL default '0',
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1";
		$result=pwg_query($sql);
		if($result)
		{
			$sql="CREATE TABLE `".$this->prefixeTable.$this->plugin_name."_polls_by_user` (
				  `poll_id` int(11) NOT NULL default '0',
				  `user_id` varchar(15) NOT NULL default '2',
				  PRIMARY KEY (`poll_id`, `user_id`)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1";
			$result=pwg_query($sql);
			return($result);
			
		}
		//si création échoue, on supprime ce qui a peut-être été créé
		$this->drop_tables();
		return(false);
	}

	/* suppression des tables */
	function drop_tables()
	{
		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_polls";
		$result=pwg_query($sql);

		$sql="DROP TABLE IF EXISTS ".$this->prefixeTable.$this->plugin_name."_polls_by_user";
		$result=pwg_query($sql);
	}

	/* restitue les enumération de la table history */
	function get_section_enum($add)
	{
		$sql = 'SHOW COLUMNS FROM '.HISTORY_TABLE.' LIKE "section"';
		$result=pwg_query($sql);
		if($result)
		{
			$row = mysql_fetch_array($result);
			$list=substr($row['Type'], 5, strlen($row['Type'])-6);
			$returned=explode(',', $list);
			if((strpos($list, "'$add'")===false)&&($add!='')) { array_push($returned, "'$add'"); }
			return($returned);
		}
	}

	function add_enum_to_history()
	{	
		$enums=implode(',', $this->get_section_enum('mypolls'));
		$sql="ALTER TABLE ".HISTORY_TABLE."
				 CHANGE `section` `section` 
				 ENUM (".$enums.") ;";
		$result=pwg_query($sql);
		return($result);
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DIVERSES
	   ---------------------------------------------------------------------------------------------- */

	 /* ------------------------------------------------------------------------------------------
	   restitue l'id du dernier poll
	    ------------------------------------------------------------------------------------------ */
	function get_last_poll_id()
	{
		$sql="SELECT id FROM ".$this->polls_table." ORDER BY id desc LIMIT 0,1";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0)
			{ 
				$row=mysql_fetch_row($result); 
				return($row[0]);
			}
		}	
		return(0);
	}

	 /* ------------------------------------------------------------------------------------------
	   restitue les données d'un poll
	    ------------------------------------------------------------------------------------------ */
	function get_poll_values($poll_id)
	{
		$sql="SELECT * FROM ".$this->polls_table." WHERE id = $poll_id";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0)
			{ 
				$row=mysql_fetch_array($result); 
				return($row);
			}
		}	
		return(false);
	}


	 /* ------------------------------------------------------------------------------------------
	   restitue un tableau de tous les polls  
	    ------------------------------------------------------------------------------------------ */
	function get_polls_list($user_id=1, $view_all=true)
	{
		$returned=array();

		$sql="SELECT id, date, title, allow_guests, visible, total FROM ".$this->polls_table;
		$sql_where='';

		if($user_id==2)
		{ $sql_where.=" WHERE allow_guests = 'y' "; }

		if(!$view_all)
		{ 
			if($sql_where=='') { $sql_where.=" WHERE "; } else { $sql_where.=" AND "; }
			$sql_where.=" visible = 'y' "; 
		}
		
		$sql_order=" ORDER BY id desc";

		$result=pwg_query($sql.$sql_where.$sql_order);
		if($result)
		{
			while($row=mysql_fetch_assoc($result))
			{ 
				array_push($returned, $row);
			}
		}	
		return($returned);
	}

	 /* ------------------------------------------------------------------------------------------
	   comptabilise les visites 
	    ------------------------------------------------------------------------------------------ */
	function count_visit($poll_id, $mode)
	{	// $mode = 'before' / 'after'
		
		$sql="UPDATE ".$this->polls_table;
		if($mode=='before')
		{ $sql.=" SET visit_without_vote = visit_without_vote + 1 "; }
		else
		{ $sql.=" SET visit_after_vote = visit_after_vote + 1 "; }
		$sql.=" WHERE id = $poll_id ";
		$result=pwg_query($sql);
		return($result);
	}

	 /* ------------------------------------------------------------------------------------------
	   effectue un vote
	    ------------------------------------------------------------------------------------------ */
	function do_vote($poll_id, $vote_value, $user_id, $ip)
	{
		$sql="UPDATE ".$this->polls_table."
			SET	c".$vote_value."_choose = c".$vote_value."_choose + 1,
				total = total + 1, 
				visit_without_vote = visit_without_vote - 1
			WHERE id = $poll_id";
		$result=pwg_query($sql);
		if($result)
		{
			if($user_id==2) { $vote_id = $ip; } else { $vote_id = $user_id; }
			$sql="INSERT INTO ".$this->polls_by_user_table."
				VALUES ('".$poll_id."','".$vote_id."')";
			$result=pwg_query($sql);
			return($result);
		}
		return(false);
	}
	
	 /* ------------------------------------------------------------------------------------------
	   l'utilisateur a-t'il déjà voté ?
	    ------------------------------------------------------------------------------------------ */
	function get_poll_user_vote($poll_id, $user_id, $ip)
	{
		$sql="	SELECT user_id FROM ".$this->polls_by_user_table."
			WHERE poll_id=$poll_id AND user_id = '$ip'
			UNION
			SELECT user_id FROM ".$this->polls_by_user_table." 
			WHERE poll_id=$poll_id AND user_id = '$user_id'";
		$result=pwg_query($sql);
		if($result)
		{
			if(mysql_num_rows($result)>0) 
			{ return(true); }
		}
		return(false);
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DE L'ADMINISTRATEUR
	   ---------------------------------------------------------------------------------------------- */

	 /* ------------------------------------------------------------------------------------------
	   génère les onglets de la page 
	    ------------------------------------------------------------------------------------------ */
	 function make_tabsheet($selected_page)
	 { //derived from pwg function_tabsheet.inc.php
	  global $template;

		  $page['tabsheet'] = array
		  (
		    'global_view' => array
		     (
		      'caption' => l10n('MyPolls_global_view'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=global_view',
		      'selected' => ($selected_page=='global_view')	
		     ),
		    'detail_view' => array
		     (
		      'caption' => l10n('MyPolls_detail_view'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id='.$this->get_last_poll_id(),
		      'selected' => ($selected_page=='detail_view')	
		     ),
		    'create_poll' => array
		     (
		      'caption' => l10n('MyPolls_create_poll'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=create_poll',
		      'selected' => ($selected_page=='create_poll')
		     ),
		    'config' => array
		     (
		      'caption' => l10n('MyPolls_config'),
		      'url' => $this->pagelink.'&fMyPolls_tabsheet=config',
		      'selected' => ($selected_page=='config')
		     )
		  );


	  if (count($page['tabsheet']) > 0)
	  {
	    $template->set_filename('tabsheet', 'admin/tabsheet.tpl');

	    foreach ($page['tabsheet'] as $tab_name => $tab)
	    {
	      $is_selected = ($tab['selected'] == 1);
	      $template->assign_block_vars
	      (
	        'tab',
	        array
	        (
	          'CLASSNAME' => ($is_selected ? 'selected_tab' : 'normal_tab'),
	          'URL' => $tab['url'],
	          'CAPTION' => $tab['caption']
	        )
	      );

	      if ($is_selected)
	      {
	        $template->assign_vars(
	          array('TABSHEET_TITLE' => '['.$tab['caption'].']'));
	      }
	    }

	    $template->assign_var_from_handle('TABSHEET', 'tabsheet');
	  }
	 }


	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la page admin
	    ------------------------------------------------------------------------------------------ */
	function display_admin_page()
	{
		$this->make_tabsheet($_REQUEST['fMyPolls_tabsheet']);

		if(isset($_POST['fMyPolls_create_new_poll']))
		{
			$this->create_poll();
		}
		elseif(isset($_POST['fMyPolls_modify_poll']))
		{
			$this->modify_poll();
		}
		elseif(isset($_POST['fMyPolls_delete_poll']))
		{
			$this->delete_poll();
		}
		else
		{
			switch($_REQUEST['fMyPolls_tabsheet'])
			{
				case 'global_view': 
					$this->display_global_view(); 
					break;
				case 'detail_view':
					if(isset($_REQUEST['fMyPolls_poll_id']))
					{ $this->display_detail_view($_REQUEST['fMyPolls_poll_id']); }
					else
					{ $this->display_detail_view($this->get_last_poll_id()); }
					break;
				case 'create_poll': 
					if(isset($_REQUEST['fMyPolls_poll_id']))
					{ $this->display_modify_poll_form($_REQUEST['fMyPolls_poll_id'], '', false); }
					else
					{ $this->display_create_poll_form('', array()); }
					break;
				case 'config': 
					$this->display_config();
					break;
			}
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la configuration
	    ------------------------------------------------------------------------------------------ */
	function display_config()
	{
		global $template;
		$yes_no = array('y', 'n');

		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_config.tpl');
		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_config_title'));

		if(isset($_POST['submit']))
		{
			reset($this->my_config); 
			while (list($key, $val) = each($this->my_config)) 
			{ if(isset($_POST['f_'.$key])) { $this->my_config[$key] = $_POST['f_'.$key]; } }

			if($this->save_config())
			{ $template->assign_var("MYPOLLS_RESULT_SAVE", "<p class='infos'>".l10n('MyPolls_config_saved')."<br/></p>"); }
		}

		/* affectation standard pour zones de saisie */
		reset($this->my_config); 
		while (list($key, $val) = each($this->my_config)) 
		{ $template->assign_var("f_".$key, $val); }

		/* gestion spécifique pour les oui/non */
		$yesno_list=array('MyPolls_visible_default' => 'MyPolls_visible_default_list',
				  'MyPolls_allow_guests_default' => 'MyPolls_allow_guests_default_list');
		reset($yesno_list);
		while (list($yesno_key, $yesno_val) = each($yesno_list)) 
		{
			reset($yes_no); 
			while (list($key, $val) = each($yes_no)) 
			{
			 	if($val==$this->my_config[$yesno_key])
				{ $select='selected'; } else { $select= ''; }

				$template->assign_block_vars(
					$yesno_val,
			      		array(
					        'VALUE' => $val,
					        'SELECT' => $select,
					        'LABEL' => l10n('MyPolls_yesno_'.$val)
			        	)
			      	);
			}
		}


		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la liste des sondages
	    ------------------------------------------------------------------------------------------ */
	function display_global_view()
	{
		global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_global_view.tpl');

		$polls_list=$this->get_polls_list();
		if(count($polls_list)>1)
		{ $nb='n'; } else { $nb=count($polls_list); }

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_polls_list'));
		$template->assign_var("MYPOLLS_NB_POLLS", sprintf(l10n('MyPolls_number_of_polls'.$nb), count($polls_list)));
		
		for($i=0;$i<count($polls_list);$i++)
		{
			$template->assign_block_vars(
			      'mypolls_nb_polls_row',
			      array(
				'ID' => $polls_list[$i]['id'],
				'DATE' => $polls_list[$i]['date'],
				'TITLE' => $polls_list[$i]['title'],
				'ALLOW_GUESTS' => l10n('MyPolls_yesno_'.$polls_list[$i]['allow_guests']),
				'VISIBLE' => l10n('MyPolls_yesno_'.$polls_list[$i]['visible']),
				'TOTAL' => $polls_list[$i]['total'],
				'LNK_VIEW' => $this->pagelink.'&fMyPolls_tabsheet=detail_view&fMyPolls_poll_id='.$polls_list[$i]['id'],
				'LNK_MODIFY' => $this->pagelink.'&fMyPolls_tabsheet=create_poll&fMyPolls_poll_id='.$polls_list[$i]['id']
				)
			      );
		}

		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}


	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la création d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_create_poll_form($alertmsg, $default_values)
	{
	  	global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_create_poll.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_create_new_poll'));

		if(count($default_values)==0)
		{ 
			$default_values=array('title' => '', 'description' => '', 
					'visible' => $this->my_config['MyPolls_visible_default'], 
					'allow_guests' => $this->my_config['MyPolls_allow_guests_default'],
					'c1_text' => '', 'c2_text' => '', 'c3_text' => '', 'c4_text' => '', 'c5_text' => '',
					'c6_text' => '', 'c7_text' => '', 'c8_text' => '', 'c9_text' => '', 'c10_text' => ''); 
		}

		for($i=1;$i<=10;$i++)
		{
			if($i<3) { $need= "<sup  style='color:rgb(255,255,0)'>*</sup>"; } else { $need=""; }
			$template->assign_block_vars(
			      'boucle_de_la_flemme',
			      array('NUM' => $i,
				    'NEED' => $need,
				    'CVALUE' => $default_values['c'.$i.'_text'])
			      );			
		}

		$template->assign_var('MYPOLLS_ATT_TITLE', $default_values['title']);
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $default_values['description']);

		if($default_values['visible']=='y')
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_NO', 'selected'); }

		if($default_values['allow_guests']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_NO', 'selected'); }

		$template->assign_block_vars('mypolls_en_creation', array());
		if($alertmsg!='') { $template->assign_block_vars('mypolls_alert_nfo', array('TYPE' => 'errors', 'MSG' => l10n($alertmsg))); }
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la modification d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_modify_poll_form($poll_id, $alertmsg, $iserror)
	{
	  	global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_create_poll.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_modify_poll'));

		$poll_values=$this->get_poll_values($poll_id);

		
		for($i=1;$i<=10;$i++)
		{
			if($i<3) { $need= "<sup  style='color:rgb(255,255,0)'>*</sup>"; } else { $need=""; }
			$template->assign_block_vars(
			      'boucle_de_la_flemme',
			      array('NUM' => $i,
				    'NEED' => $need,
				    'CVALUE' => $poll_values['c'.$i.'_text']
				)
			      );			
		}
		
		$template->assign_var('MYPOLLS_ATT_TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $poll_values['description']);

		if($poll_values['visible']=='y')
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_VISIBLE_NO', 'selected'); }

		if($poll_values['allow_guests']=='y')
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_YES', 'selected'); }
		else
		{ $template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS_NO', 'selected'); }

		if($iserror) { $msg_type = 'errors'; } else { $msg_type = 'infos'; }
		if($alertmsg!='') { $template->assign_block_vars('mypolls_alert_nfo', array('TYPE' => $msg_type, 'MSG' => l10n($alertmsg))); }

		$template->assign_block_vars('mypolls_en_modification', array('ID' => $poll_id));
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}

	 /* ------------------------------------------------------------------------------------------
	   gestion de l'affichage de la consultation d'un sondage
	    ------------------------------------------------------------------------------------------ */
	function display_detail_view($poll_id)
	{
	  	global $template;
		$template->set_filename('body_page', dirname(__FILE__).'/admin/plugin_admin_detail_view.tpl');

		$template->assign_var("MYPOLLS_TITLE", l10n('MyPolls_detail_view_title'));

		$poll_values=$this->get_poll_values($poll_id);

		$i=1;
		while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
		{
			if($poll_values['total']>0)
			{ $pct=round(100*$poll_values['c'.$i.'_choose'] / $poll_values['total'], 2); }
			else
			{ $pct=0; }

			$barwidth=ceil($pct * $this->my_config['MyPolls_MaxBarWidth']/100);

			$template->assign_block_vars(
			      'mypolls_questions_row',
			      array('ID' => $i,
				    'QUESTION' => $poll_values['c'.$i.'_text'],
				    'NBANSWERS' => $poll_values['c'.$i.'_choose'],
				    'PCT' => $pct."%",
				    'BARWIDTH' => $barwidth
				)
			      );
			$i++;
		}
		
		$template->assign_var('MYPOLLS_MAXBARWIDTH', $this->my_config['MyPolls_MaxBarWidth']);
		$template->assign_var('MYPOLLS_ATT_ID', $poll_values['id']);
		$template->assign_var('MYPOLLS_ATT_DATE', $poll_values['date']);
		$template->assign_var('MYPOLLS_ATT_TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_ATT_TOTAL', $poll_values['total']);
		$template->assign_var('MYPOLLS_ATT_VISIBLE', l10n('MyPolls_yesno_'.$poll_values['visible']));
		$template->assign_var('MYPOLLS_ATT_ALLOW_GUESTS', l10n('MyPolls_yesno_'.$poll_values['allow_guests']));
		$template->assign_var('MYPOLLS_ATT_DESCRIPTION', $poll_values['description']);
		$template->assign_var_from_handle('MYPOLLS_BODY_PAGE', 'body_page');
	}


	 /* ------------------------------------------------------------------------------------------
	   création d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function create_poll()
	{
		$sql="INSERT INTO ".$this->polls_table."
		 VALUES ('', '".date("Y-m-d H:i:s")."', 
			'".$_REQUEST['fMyPolls_att_title']."', 
			'".$_REQUEST['fMyPolls_att_description']."', 
			'".substr($_REQUEST['fMyPolls_att_allow_guests'],0,1)."', 
			'".substr($_REQUEST['fMyPolls_att_visible'],0,1)."', 
			'".$_REQUEST['fMyPolls_att_c1_text']."', '',
			'".$_REQUEST['fMyPolls_att_c2_text']."', '',
			'".$_REQUEST['fMyPolls_att_c3_text']."', '',
			'".$_REQUEST['fMyPolls_att_c4_text']."', '',
			'".$_REQUEST['fMyPolls_att_c5_text']."', '',
			'".$_REQUEST['fMyPolls_att_c6_text']."', '',
			'".$_REQUEST['fMyPolls_att_c7_text']."', '',
			'".$_REQUEST['fMyPolls_att_c8_text']."', '',
			'".$_REQUEST['fMyPolls_att_c9_text']."', '',
			'".$_REQUEST['fMyPolls_att_c10_text']."', '', '', '', '')";
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_modify_poll_form(mysql_insert_id(), 'MyPolls_create_is_ok', false);
		}
		else
		{
			$default_values=array('title' => $_REQUEST['fMyPolls_att_title'], 
					'description' => $_REQUEST['fMyPolls_att_description'], 
					'visible' => substr($_REQUEST['fMyPolls_att_visible'],0,1), 
					'allow_guests' => substr($_REQUEST['fMyPolls_att_allow_guests'],0,1),
					'c1_text' => $_REQUEST['fMyPolls_att_c1_text'], 
					'c2_text' => $_REQUEST['fMyPolls_att_c2_text'], 
					'c3_text' => $_REQUEST['fMyPolls_att_c3_text'],  
					'c4_text' => $_REQUEST['fMyPolls_att_c4_text'],  
					'c5_text' => $_REQUEST['fMyPolls_att_c5_text'], 
					'c6_text' => $_REQUEST['fMyPolls_att_c6_text'],  
					'c7_text' => $_REQUEST['fMyPolls_att_c7_text'],  
					'c8_text' => $_REQUEST['fMyPolls_att_c8_text'],  
					'c9_text' => $_REQUEST['fMyPolls_att_c9_text'],  
					'c10_text' => $_REQUEST['fMyPolls_att_c10_text']); 
			$this->display_create_poll_form('MyPolls_create_is_ko', $default_values);	
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   modification d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function modify_poll()
	{
		$sql="UPDATE ".$this->polls_table."
		SET 	title = '".$_REQUEST['fMyPolls_att_title']."', 
			description = '".$_REQUEST['fMyPolls_att_description']."', 
			allow_guests = '".substr($_REQUEST['fMyPolls_att_allow_guests'],0,1)."', 
			visible = '".substr($_REQUEST['fMyPolls_att_visible'],0,1)."', 
			c1_text = '".$_REQUEST['fMyPolls_att_c1_text']."', 
			c2_text = '".$_REQUEST['fMyPolls_att_c2_text']."', 
			c3_text = '".$_REQUEST['fMyPolls_att_c3_text']."', 
			c4_text = '".$_REQUEST['fMyPolls_att_c4_text']."', 
			c5_text = '".$_REQUEST['fMyPolls_att_c5_text']."', 
			c6_text = '".$_REQUEST['fMyPolls_att_c6_text']."', 
			c7_text = '".$_REQUEST['fMyPolls_att_c7_text']."', 
			c8_text = '".$_REQUEST['fMyPolls_att_c8_text']."', 
			c9_text = '".$_REQUEST['fMyPolls_att_c9_text']."', 
			c10_text = '".$_REQUEST['fMyPolls_att_c10_text']."'
		WHERE id = ".$_REQUEST['fMyPolls_att_id'];
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_modify_is_ok', false);
		}
		else
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_modify_is_ko', true);
		}
	}

	 /* ------------------------------------------------------------------------------------------
	   suppression d'un sondage dans la base 
	    ------------------------------------------------------------------------------------------ */
	function delete_poll()
	{
		$sql="DELETE FROM ".$this->polls_table." WHERE id = ".$_REQUEST['fMyPolls_att_id'];
		$result=pwg_query($sql);
		if($result)
		{
			$this->display_global_view();
		}
		else
		{
			$this->display_modify_poll_form($_REQUEST['fMyPolls_att_id'], 'MyPolls_delete_is_ko', true);
		}
	}


	/* ----------------------------------------------------------------------------------------------
		FONCTIONS DE LA GALLERIE
	   ---------------------------------------------------------------------------------------------- */

	/* ----------------------------------------------------------------------------------------------
		Met à jour le menu de la gallerie
	   ---------------------------------------------------------------------------------------------- */
	function maj_menubar()
	{
		global $template, $user, $lang;

		include_once(get_language_filepath('plugin.lang.php', PLUGIN_PATH));

		$tpl_code = '
		<!-- BEGIN mypolls -->
		<dl id="mbMyPolls">
		<dt>{mypolls.TITLE}</dt>
		<dd><ul>
		<!-- BEGIN link -->
		<li><a href="{mypolls.link.URL}">{mypolls.link.LABEL}</a></li>
		<!-- END link -->
		</ul></dd></dl>
		<!-- END mypolls -->
		';
		// compatibilité avec le plugin "MenuBarManager" 
		// [http://phpwebgallery.net/ext/extension_view.php?eid=164]
		if (function_exists('set_menubar_manager_data'))
		{
			set_menubar_manager_data('MyPolls', $tpl_code, 'begin');
		}
		else
		{	//plugin "MenuBarManager" non installé
			$template->loadfile('menubar');
			$template->uncompiled_code['menubar'] = str_replace('<div id="menubar">', 
										'<div id="menubar">'.$tpl_code, $template->uncompiled_code['menubar']);
		}
		$polls_list=$this->get_polls_list($user['user_id'], false);

		if(count($polls_list)>0)
		{
			if($this->my_config['MyPolls_MenuBar_Title']!='')
			{ $template->assign_block_vars('mypolls', array('TITLE' => $this->my_config['MyPolls_MenuBar_Title'])); }
			else
			{ $template->assign_block_vars('mypolls', array('TITLE' => l10n('MyPolls_menubar_default_title'))); }

			for($i=0;$i<count($polls_list);$i++)
			{
				$template->assign_block_vars('mypolls.link', array(
					'LABEL' => $polls_list[$i]['title'],
					'URL' => PHPWG_ROOT_PATH.'index.php?/mypolls/'.$polls_list[$i]['id']
					)
				);
			}
		}
	}

	/* ----------------------------------------------------------------------------------------------
		gestion de la section "mypolls" (utilisée dans les logs)
	   ---------------------------------------------------------------------------------------------- */
	function init_section_mypolls()
	{
		global $tokens, $page;
		
		if ($tokens[0] == 'mypolls')
		{ $page['section'] = 'mypolls'; }
	}

	/* ----------------------------------------------------------------------------------------------
		gestion des pages "mypolls"
	   ---------------------------------------------------------------------------------------------- */
	function index_mypolls()
	{
		global $page, $user;

		if($page['section'] == 'mypolls')
		{
			$poll_id=explode('mypolls/', $_SERVER['REQUEST_URI']);
			$poll_id=explode('&', $poll_id[1]);

			if(isset($_POST['submit_poll_answer']))
			{
				$this->do_vote($poll_id[0], $_REQUEST['fMyPolls_answer'], $user['user_id'], $_SERVER['REMOTE_ADDR']);
			}
			$this->display_poll_page($poll_id[0]);
		}
	}

	/* ----------------------------------------------------------------------------------------------
		affichage de la page en mode formulaire ou résultat
	   ---------------------------------------------------------------------------------------------- */
	function display_poll_page($poll_id)
	{
		global $template, $user;

		$template->set_filename('body_page', dirname(__FILE__).'/plugin_polls_requests.tpl');

		$poll_values=$this->get_poll_values($poll_id);

		if(($poll_values['allow_guests']=='n')&&($user['user_id']==2))
		{
			page_not_found('This page does not exist', 'index.php?');
			return(false);
		}

		$template->assign_var('TITLE', $poll_values['title']);
		$template->assign_var('MYPOLLS_DESCRIPTION', $poll_values['description']);

		//$template->assign_var('PLUGIN_INDEX_ACTIONS' , '');
		if($this->get_poll_user_vote($poll_id, $user['user_id'], $_SERVER['REMOTE_ADDR']))
		{ // a déjà voté
			$this->count_visit($poll_id, 'after');

			$template->assign_block_vars('poll_vote_result', array('TOTAL' => $poll_values['total']));

			$i=1;
			while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
			{
				if($poll_values['total']>0)
				{ $pct=round(100*$poll_values['c'.$i.'_choose'] / $poll_values['total'], 2); }
				else
				{ $pct=0; }

				$barwidth=ceil($pct * $this->my_config['MyPolls_MaxBarWidth']/100);

				$template->assign_block_vars(
				      'poll_vote_result.mypolls_questions_row',
				      array('ID' => $i,
					    'QUESTION' => $poll_values['c'.$i.'_text'],
					    'NBANSWERS' => $poll_values['c'.$i.'_choose'],
					    'PCT' => $pct."%",
					    'BARWIDTH' => $barwidth
					)
				      );
				$i++;
			}
		}
		else
		{ // n'a jamais voté
			$this->count_visit($poll_id, 'before');

			$template->assign_block_vars('poll_vote_form', array());
			$i=1;
			while(($i<=10)&&($poll_values['c'.$i.'_text']!=''))
			{
				if($i==1) { $checked='checked'; } else { $checked=''; }
				$template->assign_block_vars('poll_vote_form.poll_questions', 
						array('LABEL' => $poll_values['c'.$i.'_text'],
							'NUM' => $i,
							'SELECTED' => $checked
						)
					);
				$i++;
			}
		}

		unset($template->_tpldata['mode_posted.']);
		unset($template->_tpldata['mode_created.']);
		$template->assign_var_from_handle('PLUGIN_INDEX_CONTENT_BEGIN', 'body_page');
	}
}


?>
